---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by mike.
--- DateTime: 5/23/20 11:28 PM
---

local RPD                 = require "scripts/lib/commonClasses"
local spell               = require "scripts/lib/spell"

local distracted          = {}
distracted["PASSIVE"]     = true
distracted["SLEEPING"]    = true
distracted["FLEEING"]     = true
distracted["HORRIFIED"]   = true
distracted["RUNNINGAMOK"] = true

return spell.init{
    desc  = function ()
        return {
            image         = 2,
            imageFile     = "spellsIcons/rogue.png",
            name          = "Backstab_Name",
            info          = "Backstab_Info",
            magicAffinity = "Rogue",
            targetingType = "self",
            level         = 2,
            castTime      = 1,
            spellCost     = 2
        }
    end,

    cast = function(self, spell, caster)

        local level = caster:level()
        local ownPos = caster:getPos()

        local victim = caster:getNearestEnemy()

        if victim == nil or level:distance(ownPos, victim:getPos()) > 1 then
            RPD.glogn("Backstab_TooFar")
            return false
        end

        if not (distracted[victim:getState():getTag()] or victim:isParalysed()) then
            RPD.glogn("Backstab_Aware")
            return false
        end

        victim:getSprite():showStatus(0xff2030,"backstab")

        local weapon = caster:getBelongings().weapon
        local secondaryWeapon = caster:getBelongings().leftHand
        local damage = math.sqrt(caster:skillLevel()) * (weapon:damageRoll(caster) + secondaryWeapon:damageRoll(caster))

        victim:damage(damage, caster)
        RPD.Sfx.Wound:hit(victim)

        return true
    end
}