---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by mike.
--- DateTime: 1/25/21 12:16 AM
---

local RPD = require "scripts/lib/commonClasses"

local spell = require "scripts/lib/spell"

local beasts = {"Snail", "Rat", "Crab", "Swarm", "Bat", "Spinner", "Scorpio", "Worm"}

return spell.init{
    desc  = function ()
        return {
            image         = 3,
            imageFile     = "spellsIcons/hunting.png",
            name          = "SummonBeast_Name",
            info          = "SummonBeast_Info",
            magicAffinity = "Huntress",
            targetingType = "self",
            level         = 4,
            castTime      = 1,
            spellCost     = 20
        }
    end,

    cast = function(self, spell, caster)
        local skillLevel = caster:skillLevel()

        RPD.forCellsAround(caster:getPos(), function(cell)
            if not RPD.Actor:findChar(cell) and caster:level():isPassable(cell) then
                if math.random() > 1/skillLevel then
                    local beast = beasts[math.min(1,  math.max(math.random(skillLevel/2, skillLevel+1), #beasts))]
                    if beast then
                        beast = RPD.spawnMob(beast, cell):makePet(caster)
                        beast:say('SummonBeast_AtYourCommand')
                    end
                end
            end

        end)

        return true
    end
}